class EmeryController < ApplicationController
# TODO Wikiページ生成機能．．．by keisen
# TODO Twitter連動更新機能．．．by keisen
# TODO Skype連動(どんな？)機能．．．by keisen
# TODO リアル更新機能．．．．by keisen

# -- filters ----------------------------------------------------------------- #
  before_filter :login_required, :except => [:twitter,:twitter_entry,:load_access_log]
  before_filter :load_configuration,
                :only => [:index, :new_entry,
                          :entries, :create_entry, :preview_entry, :update_entry, :edit_entry,
                          :comments,
                          :trackbacks,
                          :my_clipboads, :new_my_clipboad, :create_my_clipboad, :update_my_clipboad, :edit_my_clipboad,
                          :design, :edit_css, :select_css,
                          :data_setting, :data_import,
                          :file_popup, :upload_file,
                          :config, :update_config]

# -- cache sweepers ---------------------------------------------------------- #
  cache_sweeper :configuration_sweeper, :only => [:update_config]
  cache_sweeper :diary_sweeper,
                :entry_sweeper,
                :only => [:create_entry, :update_entry, :delete_entries, :twitter_entry]
  cache_sweeper :comment_sweeper, :only => [:update_comment, :delete_comments]
  cache_sweeper :trackback_sweeper, :only => [:delete_trackbacks]


# -- index ------------------------------------------------------------------- #
  def index
    # do nothing.
  end

# -- for entry --------------------------------------------------------------- #
  def entries
    @pages, @entries = paginate :entries,
                                :per_page => 10,
                                :order => 'diary_id desc'
  end

  def new_entry
    @entry = Entry.new
    paginate_my_clipboad 5
  end

  def preview_entry
    # FIXME 「タイトルのスタイルが本物と同じだと嬉しいな」なんて贅沢なことを思ってしまいました(w．．．by keisen
    @entry = Entry.new params[:entry]
    render :partial => "preview"
  end

  def create_entry
    # TODO Viewに日付指定項目を追加．．．by keisen
    # TODO Hatena記法を利用可能に．．．by keisen
    # TODO PukiWiki記法を利用可能に．．．by keisen
    # TODO タイトルをリンク化する機能があったらいいな．．．by keisen
    today = Date.today
    diary = Diary.find :first,
                       :conditions => ["date=?", today]
    unless diary
      diary = Diary.new
      diary.date = today
    end
    @entry = Entry.new params[:entry]
    # XXX emerydev.dip.jpで動作確認してないものはコミットしないこと！．．．by keisen
    #update_tags @entry

    diary.entries << @entry
    if diary.save
      #@entry.tag_list = (params[:tags])
      send_trackback @entry
      redirect_to :controller => :blog, :action => :index, :page => '1'
    else
      render :action => :new_entry
    end
  end

  def edit_entry
    @entry = Entry.find params[:id]
    paginate_my_clipboad 5
  end

  def update_entry
    # FIXME 存在チェック＋更新を一発やる方法があったかと．．．by keisen
    @entry = Entry.find params[:entry][:id].to_i
    if @entry.update_attributes params[:entry]
      # XXX emerydev.dip.jpで動作確認してないものはコミットしないこと！．．．by keisen
      #update_tags @entry
      send_trackback @entry
      redirect_to :action => :entries
    else
      render :action => :edit_entry
    end
  end

  def delete_entries
    if params[:entry].nil?
      flash[:error] = '更新対象が選択されていません。'
    else
      params[:entry].each do |id, attr|
        entry = Entry.find(id)
        diary = Diary.find entry.diary_id
        diary.entries.destroy entry
        diary.destroy if diary.entries.empty?
      end
      flash[:info] = '正常に更新されました。'
    end
    redirect_to :action => :entries
  end

# -- for comment ------------------------------------------------------------- #
  def comments
    @pages, @comments = paginate :comments,
                                 :per_page => 20,
                                 :order => 'created_at desc'
  end

  def edit_comment
    # FIXME 使っていない？．．．by keisen
    @comment = Comment.find params[id]
  end

  def update_comment
    # FIXME 使っていない？．．．by keisen
    @comment = Comment.find params[:id]
    if @comment.update_attributes params[:comment]
      redirect_to :action => :entries
    else
      render :action => :comments
    end
  end

  def delete_comments
    if params[:comments].nil?
      flash[:error] = '更新対象が選択されていません。'
    else
      params[:comments].each do |id, attr|
        Comment.destroy id.to_i
      end
      flash[:info] = '正常に更新されました。'
    end
    redirect_to :action => :comments
  end

# -- for trackback ----------------------------------------------------------- #
  def trackbacks
    @pages, @trackbacks = paginate :trackbacks,
                                   :per_page => 20,
                                   :order => 'created_at desc'
  end

  def add_tb_column
    # FIXME remove_tb_columnが欲しいと思ってしまいました．．．by keisen
    # FIXME そして贅沢にももう少し画面が綺麗だと良いなぁと思ってしまいました．．．by keisen
    render_text "<p><input id='entry_trackback_url' name='entry[trackback_url]' size='50' type='text' /></p>"
  end

  def delete_trackbacks
    if params[:trackbacks].nil?
      flash[:error] = '更新対象が選択されていません。'
    else
      params[:trackbacks].each do |id, attr|
        Trackback.destroy id.to_i
      end
      flash[:info] = '正常に更新されました。'
    end
    redirect_to :action => :trackbacks
  end

# -- for clipboad -------------------------------------------------------------- #
  def my_clipboads
    paginate_my_clipboad 20
  end
  
  def my_clipboads_partial
    paginate_my_clipboad 5
    render :partial => 'my_clipboads'
  end
  
  hide_action :paginate_my_clipboad
  def paginate_my_clipboad per_page
    @pages, @my_clipboads = paginate :my_clipboads,
                                 :per_page => per_page,
                                 :order => 'use_count desc'
  end
  
  def countup_my_clipboad
    my_clipboad = MyClipboad.find params[:id]
    my_clipboad.use_count = my_clipboad.use_count + 1
    my_clipboad.update
    render :partial => 'my_clipboads'
  end
  
  def new_my_clipboad
    @my_clipboad = MyClipboad.new
    render :action => :edit_my_clipboad
  end
  
  def edit_my_clipboad
    @my_clipboad = MyClipboad.find params[:id]
  end

  def create_my_clipboad
    if MyClipboad.create(:body => params[:my_clipboad][:body])
      redirect_to :action => :my_clipboads
    else
      render :action => :edit_my_clipboad
    end
  end

  def update_my_clipboad
    @my_clipboad = MyClipboad.find params[:my_clipboad][:id]
    if @my_clipboad.update_attributes params[:my_clipboad]
      redirect_to :action => :my_clipboads
    else
      render :action => :edit_my_clipboad
    end
  end

  def delete_my_clipboads
    if params[:my_clipboads].nil?
      flash[:error] = '更新対象が選択されていません。'
    else
      params[:my_clipboads].each do |id, attr|
        MyClipboad.destroy id.to_i
      end
      flash[:info] = '正常に更新されました。'
    end
    redirect_to :action => :my_clipboads
  end

# -- for design -------------------------------------------------------------- #

  # FIXME 一旦、クラス変数で定義しておく(こういうものはHelper？) by ぁ
  # Blogで使用するCSSファイル
  @@css_file = "#{RAILS_ROOT}/public/stylesheets/default-blog.css"
  # Blogで使用するCSSファイルのログ記録名
  @@name_name_css = "DEFAULT_CSS"

  # 「デザイン」メニューのエントリポイント
  def design
    # 現在フロントで使用中のCSSファイルの内容を、@css_textに取り出します。
    @css_text = File.read(@@css_file)
    @blog_css = HistoryLog.find(:first,
        :conditions => "log_name = '#{@@name_name_css}' AND is_selected = 1")
    @hisLogs = Array.new
     HistoryLog.find(:all,
        :conditions => "log_name = '#{@@name_name_css}'",
        :order => "id desc").each{ |hisLog|
       #@up_time = hisLog.update_at #.strftime("%Y/%m/%d %H:%M:%S")
       #@up_time = @up_time + "[使用中]" if hisLog.is_selected
       @hisLogs << [hisLog.update_at, hisLog.id]
     }
        
  end
  
  # スタイルシートをテキストエリア(css[text])の内容に編集します。
  # この時、UNDO可能なように既存のCSSファイルをバックアップします。 
  def edit_css
    unless params["css"]["text"].nil?
      # Blogで使用するCSSファイルに、テキストボックスの内容を書き出します
      File.open(@@css_file, "w"){ |file|
        file.puts(params["css"]["text"])
      }
      # 同一記録名のログレコードを、(全て)未選択に。
      HistoryLog.update_all( "is_selected=false", "log_name = '#{@@name_name_css}'" )
      # 変更内容をDBに記録する
      @newLog = HistoryLog.new
      @newLog.update_at = Time.now
      @newLog.log_name = @@name_name_css
      @newLog.log_body = params["css"]["text"]
      @newLog.is_selected = true
      @newLog.save
      flash[:info] = "スタイルシートの内容を編集しました"
    end
    redirect_to :action => :design
  end
  
  # CSSの編集履歴から該当するものを探し、UNDO/REDOします
  def select_css
    unless params["blog_css"]["id"].nil?
      @selected = params["blog_css"]["id"]
      @hisLog = HistoryLog.find(:first,
        :conditions => "log_name = '#{@@name_name_css}' AND id = '#{@selected}'")
      unless @hisLog.nil?
         # UNDO/REDOのDB操作を行います
         HistoryLog.update_all( "is_selected=false", "log_name = '#{@@name_name_css}'" )
        @hisLog.is_selected = 1
        @hisLog.save
         # Blogで使用するCSSファイルに、テキストボックスの内容を書き出します
         File.open(@@css_file, "w"){ |file|
           file.puts(@hisLog.log_body)
         }
         flash[:info] = "スタイルシートを #{@hisLog.update_at.strftime("%Y/%m/%d %H:%M:%S")} 時点の変更分に戻しました"
         redirect_to :action => :design
        return
      end
    end
    flash[:info] = "スタイルシートの巻き戻しに失敗しました"
    redirect_to :action => :design
  end
  
# -- for tag --------------------------------------------------------------- #
  def view_tags
    @tag_candidates = Tag.find :all
    render :partial => "view_tag"
  end
  
# -- for import/export ------------------------------------------------------- #
# FIXME メソッド名をimport/exportにしませんか？．．．by keisen
  def data_setting
    # do nothing.
  end

  def data_import
    @uploaded = params[:upload]
    file = @uploaded['file']

    #MTConv start 
    data = Kconv.toutf8 file.read
    @diaries = EmeryHelper.convFromMt data

    @diaries.values.each{|dialy|
      dialy.save
    }

    redirect_to :action => :entries
  end

  def data_export
    diaries = Diary.find :all
    data = EmeryHelper.convToMt diaries
    send_data data ,{:filename => 'emery-export.txt'}
  end

# -- for image file upload --------------------------------------------------- #
# FIXME 日本語ファイル未対応．．．by keisen
  def file_popup
    @public_dirs = ["/"]
    Dir.glob("#{RAILS_ROOT}/public/**/*").each do | child |
      # FIXME ここは設定ファイル化したい．．．by keisen
      @public_dirs << child if File.ftype("#{RAILS_ROOT}/public" + child.gsub!("#{RAILS_ROOT}/public", "")) == "directory" && !child.match(/^\/plugin_assets/) && !child.match(/^\/javascripts\/editor/) && !child.match(/^\/index/) && !child.match(/^\/day/) && !child.match(/^\/month/) && !child.match(/^rss/)
    end
  end

  def new_dir
    file_popup
    render :partial => "new_dir"
  end

  def create_dir
    if params[:new_dir].match(/\.\./)
      flash[:error] = 'ディレクトリ名が不正です．'
    else
      begin
        FileUtils.mkdir("#{RAILS_ROOT}/public" + params[:dir] + (params[:dir] == "/" ? "" : "/") + params[:new_dir])
      rescue
        flash[:error] = 'ディレクトリ名が不正です．'
      end
    end
    redirect_to :action => :file_popup
  end

  def upload_file
    upload = params[:upload]
    path = Kconv.toutf8("#{RAILS_ROOT}/public#{upload[:dir]}/" + upload[:file].original_filename)
    File.open( path, "wb") { |f| f.write( upload[:file].read ) }
    dir = (upload[:dir] == "/") ? "" : upload[:dir]
    filename = upload[:file].original_filename
    if filename.match(/.*\.jpeg/) || filename.match(/.*\.jpg/) || filename.match(/.*\.jpe/) || filename.match(/.*\.png/) || filename.match(/.*\.bmp/) || filename.match(/.*\.gif/)
      width, height = ["", ""]
      open(path, "rb") do | fh |
        width, height = ImgUtils.get_img_size(fh.read)
      end
      img_width, img_height = [width.to_i, height.to_i]
      while img_width > 400 || img_height > 400
        img_width = (img_width * 0.8).prec_i
        img_height = (img_height * 0.8).prec_i
      end
      flash[:html] = "<a href=\"#{dir}/#{filename}\" onclick=\"window.open(\'#{dir}/#{upload[:file].original_filename}\',\'popup\',\'width=#{width},height=#{height},scrollbars=no,resizable=no,toolbar=no,directories=no,location=no,menubar=no,status=no,left=0,top=0\'); return false\"><img src=\"#{dir}/#{upload[:file].original_filename}\" height=\"#{img_height}\" width=\"#{img_width}\"></a>"
    else
      flash[:html] = "<a href=\"#{dir}/#{filename}\">#{filename}</a>"
    end
    redirect_to :action => :file_popup
  end

# -- for twitter ------------------------------------------------------------- #
  def twitter
    site = RssSite.find :first,
                        :conditions => ["url=?", "http://twitter.com/statuses/user_timeline/#{params[:login]}.rss"]
    unless site
      site = RssSite.new
      site.url = "http://twitter.com/statuses/user_timeline/#{params[:login]}.rss"
      site.title = "Twitter.com"
    end

    Net::HTTP.start('twitter.com') { |http|
      req = Net::HTTP::Get.new("/statuses/user_timeline/#{params[:login]}.rss")
      req.basic_auth params[:login], params[:password]
      rss = RSS::Parser.parse(http.request(req).body, false, false)
      unless rss
        render :text => "unfind rss."
        return true
      end

      rss.items.reverse_each do |i|
        item = RssItem.find :first,
                            :conditions => ["link=?", i.link]
        unless item
          item = RssItem.new
          item.link = i.link
          item.title = i.title.gsub(/#{params[:login]}\: /, '')
          item.description = i.title.gsub(/#{params[:login]}\: /, '')
          item.date = i.date.convert_zone("Asia/Tokyo")
          site.rss_items << item
        end
      end
    }
    site.save
    render :text => "success!"
  end

  def twitter_entry
    prev_diary = nil
    RssSite.find(:first).rss_items(:all,
                   :conditions => ["date>?", (Date.today - 2).to_time]).each do |item |
      diary = Diary.find :first,
                         :conditions => ["date=?", item.date.to_date]
      unless diary
        diary = Diary.new
        diary.date = item.date.to_date
      end
      entry = nil
      entry_title = "[twitter]今日のログ"
      diary.entries.each do |e|
        entry = e if e.title == entry_title
      end
      if entry.nil?
        entry = Entry.new
        entry.title = entry_title
        diary.entries << entry
      end
       if prev_diary.nil? || diary.date.to_s != prev_diary.date.to_s
        entry.body = ""
      end
      title = item.title.gsub(/#{params[:login]}\: /, '')
      if title.match(/^\+/)
        new_item = "<a href=\"#{item.link}\" target=\"_blank\">"
        new_item << '■'
        new_item << '　'
        new_item << "</a>"
        new_item << title.gsub(/^\+/, '')
        new_item << " ("
        new_item << item.date.strftime("At %H:%M:%S")
        new_item << ")"
        new_item << "\012"
        new_item << "\012"
        new_item << entry.body
        entry.body = new_item
        if diary.id.nil?
          diary.save
        else
          if entry.id.nil?
            entry.save
          else
            entry.update
          end
        end
        prev_diary = diary
      end
    end
    render :text => "success!"
  end

# -- for access_log ---------------------------------------------------------- #
  def load_access_log
    FileUtils.mv("#{RAILS_ROOT}/log/access.log", "#{RAILS_ROOT}/log/access.log_reading_now")
    FileUtils.touch("#{RAILS_ROOT}/log/access.log")
    file = open("#{RAILS_ROOT}/log/access.log_reading_now")
    while line = file.gets do
      if line.match(/(.+)\s(.+)\s-\s\[(.+)\]\s\"(.+)\"\s(.+)\s(.+)\s\"(.+)\"\s\"(.+)\"/)
        log = EmeryLog.new
        log.remote = $1
        log.date = DateTime.strptime($3, "%d/%h/%Y:%H:%M:%S %z")
        log.method = $4
        log.status = $5
        log.refere = $7
        log.user_agent = $8
        log.save
      end
    end
    FileUtils.remove_file("#{RAILS_ROOT}/log/access.log_reading_now")
    render :text => "success!"
  end

# -- for confituration ------------------------------------------------------- #
  def config
    #
  end

  def update_config
    @config.update_attributes params[:configuration]
    flash[:info] = '正常に更新されました。'
    redirect_to :action => :config
  end

# -- protected --------------------------------------------------------------- #
  protected
  def load_configuration
    @config = EmeryConfig.find :first
  end

  protected
  def send_trackback entry
    # FIXME Hatena,LiveDoor,gooにうまく送信できない．．．by keisen
    # FIXME 編集画面で[http://labs.gmo.jp/mt/mt-tb.cgi/156]にトラックバックを送信しようとしたら，[EMERY/app/controllers/tb_error.log]ファイルにある例外が発生しました．．．．by keisen
    # FIXME Hatenaでタイムアウトエラー発生．でもHatena側にトラックバックは送信できています．．．by keisen
    return true if entry.trackback_url.empty?
    title = @config.title
    t = Thread.new entry, title do |entry, title|
      begin
        Net::HTTP.version_1_2
        uri = URI.parse entry.trackback_url
        http = Net::HTTP.new uri.host, uri.port
        entry_url = url_for :controller => :blog,
                         :action => :day,
                         :day => entry.diary.date.to_s
        data = "title=#{URI.encode(entry.title)}"
        data << "&url=#{entry_url}" 
        data << "&blog_name=#{URI.encode(title)}"
        data << "&excerpt=#{URI.encode(entry.body.strip_html[0..254])}"
        logger.info "Info: #{uri.path}"
        logger.info "Info: #{data}"
        response = http.post uri.path, data, 'Content-type' => 'application/x-www-form-urlencoded; charset=utf-8'
        logger.info "Info: #{response}"
      rescue => ex
        logger.info "Info:" + ex
      end
    end
  end
  
  protected
  def update_tags entry
    entry.tags.each{|tag| tag.destroy}
    entry.title.scan(/[\[].*?[\]]/).uniq.each{|tagName|
      tag = Tag.new :name => tagName.gsub(/[\[|\]]/,'')
      entry.tags << tag
    }
  end
  
end
