class Entry < ActiveRecord::Base
  belongs_to :diary
  has_one    :ngram_text
  validates_presence_of :title, :body
  attr_accessor :check, :trackback_url
  def disp_body
    # FIXME ココでパースするのはあまりイケてないと思います．
    convert_br? ? body.eol_parse : body
  end
  def after_create
    text = NgramText.new
    text.title = self.title.ngram
    text.body  = self.body.ngram
    self.ngram_text = text
    text.save
  end
  def after_update
    text = self.ngram_text
    if text.nil?
      self.after_create
    else
      text.title = self.title.ngram
      text.body  = self.body.ngram
      text.update
    end
  end
  def before_destroy
    self.ngram_text.destroy
  end
end
