class Trackback < ActiveRecord::Base
  belongs_to :diary
  attr :check

  def validate
    #すべてアルファベットの場合エラー
    if title.hankaku? && excerpt.hankaku? && blog_name.hankaku?
      errors.add "Trackback is invalid. title[#{title}] excerpt[#{excerpt}] blog_name[#{blog_name}]"
      logger.info "Trackback is invalid. title[#{title}] excerpt[#{excerpt}] blog_name[#{blog_name}]"
      return
    end
    #URLが存在しない場合エラー
    begin
     Net::HTTP.version_1_2
     uri = URI.parse url
     Net::HTTP.start uri.host, uri.port do |http|
       case response = http.get(uri.path)
       when Net::HTTPSuccess then return true
       else
         errors.add "Trackback is invalid"
         return
       end
     end
    rescue => ex
      errors.add ex
      return
    end
  end
end

