class CommentSweeper < ActionController::Caching::Sweeper
  include PageCacheSweeper
  observe Comment
  
  def after_create comment
    execute comment
  end
  
  def after_update comment
    execute comment
  end

  def after_destroy comment
    execute comment
  end

  private
  def execute comment
    expire_fragment "new_comments"
    expire_fragment "side_contents"
    expire_fragment "comments#{comment.diary.id.to_s}"

    all_expire_page
  end
end
