class DiarySweeper < ActionController::Caching::Sweeper
  include PageCacheSweeper
  observe Diary
  
  def after_create diary
    execute diary
  end
  
  def after_update diary
    execute diary
  end
  
  def after_destroy diary
    execute diary
  end

  private
  def execute diary
    current = diary.date;
    
    if Diary.count(:first,
                   :select => :date,
                   :conditions => ["date >= ? and date <= ?",
                                   Date.new(current.year, current.month, 1),
                                   Date.new(current.year, current.month, -1)]) != 0
      expire_fragment "new_entries"
      expire_fragment "archives"
      expire_fragment "side_contents"
      expire_fragment "diary#{diary.id.to_s}"

      expire_page :controller => "blog", :action => "rss"
      all_expire_page
    end
  end
end
