class EntrySweeper < ActionController::Caching::Sweeper
  include PageCacheSweeper
  observe Entry
  
  def after_create entry
    execute entry
  end

  def after_update entry
    execute entry
  end
  
  def after_destroy entry
    execute entry
  end

  private
  def execute entry
    expire_fragment "new_entries"
    expire_fragment "side_contents"
    expire_fragment "entry#{entry.id.to_s}"
    expire_fragment "diary#{entry.diary.id.to_s}"
    
    expire_page :controller => :blog, :action => :rss
    all_expire_page
  end
end
