ActionController::Routing::Routes.draw do |map|
  # The priority is based upon order of creation: first created -> highest priority.
 
  # Sample of regular route:
  # map.connect 'products/:id', :controller => 'catalog', :action => 'view'
  # Keep in mind you can assign values other than :controller and :action

  # Sample of named route:
  # map.purchase 'products/:id/purchase', :controller => 'catalog', :action => 'purchase'
  # This route can be invoked with purchase_url(:id => product.id)

  # You can have the root of your site routed by hooking up '' 
  # -- just remember to delete public/index.html.
  # map.connect '', :controller => "welcome"

  # Allow downloading Web Service WSDL as a file with an extension
  # instead of a file named 'wsdl'
  # map.connect ':controller/service.wsdl', :action => 'wsdl'

  map.connect '',
              :controller => 'blog', :action => 'index',
              :page => '1'
  map.connect 'index',
              :controller => 'blog', :action => 'index',
              :page => '1'
  map.connect 'index/:page',
              :controller => 'blog', :action => 'index',
              :page => /\d+/
  map.connect 'day/:day',
              :controller => 'blog', :action => 'day',
              :day => /\d{4}-\d{2}-\d{2}/
  map.connect 'month/:month',
              :controller => 'blog', :action => 'month',
              :month => /\d{4}-\d{2}/
  map.connect 'new_comment/:id',
              :controller => 'blog', :action => 'new_comment',
              :id => /\d+/
  map.connect 'preview_comment',
              :controller => 'blog', :action => 'preview_comment'
  map.connect 'create_comment/:id',
              :controller => 'blog', :action => 'create_comment',
              :id => /\d+/
  map.connect 'rss',
              :controller => 'blog', :action => 'rss'
  map.connect 'tb/:day',
              :controller => 'blog', :action => 'tb',
              :day => /\d{4}-\d{2}-\d{2}/
  map.connect 'search/:keywords',
              :controller => 'blog', :action => 'search'

  map.connect 'user/:action',
              :controller => 'user'

  map.connect 'emery/:action/:id',
              :controller => 'emery',
              :id => /\d+/

  # delete start
  map.connect ':controller/:action/:id'
  # delete end

  # keisen only start
  map.connect 'diary/atom.xml', :controller => 'blog', :action => 'rss'
  map.connect 'diary/:y/:m/:d',
              :controller => 'blog', :action => 'day',
              :y => /\d{4}/, :m => /\d{2}/, :d => /\d{2}/
  # keisen only end
end
