require "migration_helpers"
class CreateComments < ActiveRecord::Migration
  extend MigrationHelpers
  def self.up
    create_table :comments, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :diary_id, :integer, :null => false
      t.column :author, :string, :limit => 255, :null => false
      t.column :url, :string, :limit => 255, :default => "", :null => true
      t.column :body, :text, :null => false
      t.column :created_at, :datetime, :null => false
      t.column :updated_at, :datetime, :null => false
    end
    add_index :comments, :diary_id
    foreign_key :comments, :diary_id, :diaries
  end
  def self.down
    drop_table :comments
  end
end
