class TagsEntries < ActiveRecord::Migration
  extend MigrationHelpers
  def self.up
    create_table :tags_entries, :id => false, :primary_key => [:tag_id, :entry_id], :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :tag_id, :integer, :null => false
      t.column :entry_id, :integer, :null => false
    end
    foreign_key :tags_entries, :tag_id, :tags
    foreign_key :tags_entries, :entry_id, :entries
  end

  def self.down
    drop_table :tags_entries
  end
end
