class CreateEntriesTags < ActiveRecord::Migration
  extend MigrationHelpers
  def self.up
    drop_table :tags_entries
    create_table :entries_tags, :id => false, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :tag_id, :integer, :null => false
      t.column :entry_id, :integer, :null => false
    end
    add_index :entries_tags, :tag_id, :options => {:unique => false}
    add_index :entries_tags, :entry_id, :options => {:unique => false}
    foreign_key :entries_tags, :tag_id, :tags
    foreign_key :entries_tags, :entry_id, :entries
  end

  def self.down
    drop_table :entries_tags
  end
end
