class CreateEmeryConfigs < ActiveRecord::Migration
  def self.up
    prev = Configuration.find :first
    create_table :emery_configs, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :title, :string, :limit => 255, :null => false
      t.column :description, :text, :null => true
      t.column :profile, :string
      t.column :editor, :integer, :limit => 2, :default => 0, :null=>false
      t.column :per_page, :integer, :limit => 3, :default => 5
      t.column :new_entries_limit, :integer, :limit => 3, :default => 10
      t.column :new_comments_limit, :integer, :limit => 3, :default => 10
    end
    if prev
      EmeryConfig.new(:title => prev.title,
                      :description => prev.description,
                      :profile => prev.profile,
                      :editor => prev.editor,
                      :per_page => prev.per_page,
                      :new_entries_limit => prev.new_entries_limit,
                      :new_comments_limit => prev.new_comments_limit).save
    else
      EmeryConfig.new(:title => "Please change title.",
                      :description => "",
                      :profile => "",
                      :editor => 0,
                      :per_page => 1,
                      :new_entries_limit => 10,
                      :new_comments_limit => 10).save
    end
    drop_table :configurations
  end

  def self.down
    drop_table :emery_configs
  end
end
