class DeleteTagSupport < ActiveRecord::Migration
  def self.up
    drop_table :tags
    drop_table :taggings
  
    create_table :tags, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :name, :string, :limit => 255, :null => false
    end
    add_index :tags, :name, :options => {:unique => true}
    create_table :entries_tags, :id => false, :primary_key => [:tag_id, :entry_id], :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :tag_id, :integer, :null => false
      t.column :entry_id, :integer, :null => false
    end
    
  end 
  
  def self.down
    begin 
      drop_table :entries_tags
      drop_table :tags
      create_table :tags , :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
        t.column :name , :string
      end

      create_table :taggings do |t| 
        t.column :tag_id, :integer
        t.column :taggable_id , :integer
        t.column :taggable_type , :string
      end
    rescue
    end
  end
end
