class CreateHistoryLogs < ActiveRecord::Migration
  def self.up
    create_table :history_logs, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :update_at, :datetime, :null => false
      t.column :log_name, :string, :null => false, :limit => 40
      t.column :log_body, :text, :null => false
      t.column :is_selected, :boolean, :null => false, :default => false
    end
     add_index :history_logs, [:log_name,:update_at], :options => {:unique => false}
  end

  def self.down
    drop_table :history_logs
  end
end
