class CreateRssSites < ActiveRecord::Migration
  def self.up
    create_table :rss_sites, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :url, :string, :null => false, :limit => 255
      t.column :title, :string, :limit => 255
      t.column :description, :string
      t.column :image, :string, :limit => 255
      t.column :created_at, :datetime, :null => false
      t.column :updated_at, :datetime, :null => false
    end
    add_index :rss_sites, [:url], :options => {:unique => false}
  end

  def self.down
    drop_table :rss_sites
  end
end
