class CreateRssItems < ActiveRecord::Migration
  extend MigrationHelpers
  def self.up
    create_table :rss_items, :force => true, :options => "ENGINE=innodb DEFAULT CHARSET=utf8" do |t|
      t.column :rss_site_id, :integer, :null => false
      t.column :link, :string, :limit => 255
      t.column :title, :string, :limit => 255
      t.column :description, :string
      t.column :date, :datetime
      t.column :created_at, :datetime, :null => false
      t.column :updated_at, :datetime, :null => false
    end
    add_index :rss_items, [:rss_site_id, :link], :options => {:unique => false}
    foreign_key :rss_items, :rss_site_id, :rss_sites
  end

  def self.down
    drop_table :rss_items
  end
end
