class CreateNgramTexts < ActiveRecord::Migration
  extend MigrationHelpers
  def self.up
    create_table :ngram_texts, :force => true, :options => "ENGINE=MyISAM DEFAULT CHARSET=utf8 collate utf8_unicode_ci" do |t|
      t.column :entry_id,   :integer,  :null => false
      t.column :title,      :text
      t.column :body,       :mediumtext
      t.column :created_at, :datetime, :null => false
      t.column :updated_at, :datetime, :null => false
    end
    add_index :ngram_texts, [:entry_id]
    foreign_key :ngram_texts, :entry_id, :entries
    execute('alter table ngram_texts add fulltext(title,body)');
  end

  def self.down
    drop_table :ngram_texts
  end
end
