module ImgUtils
  def self.private_module_function(name)
    module_function name
    private_class_method name
  end

  def get_img_size img_data
    raise "Argument class Error!! #{img_data.class.to_s}" unless img_data.is_a?(String)
    def img_data.analysis length, return_self = false
      @offset = 0 unless defined? @offset
      return_self = need_result ? self[@offset, length] : nil
      @offset += length
      return_self
    end
    eval "get_" + get_img_type(img_data).to_s + "_size(img_data)"
  end
  module_function :get_img_size

  def get_gif_size img_data
    img_data.analysis(6)
    img_data.analysis(4, true).unpack("vv")
  end
  private_module_function :get_gif_size

  def get_png_size img_data
    img_data.analysis(12)
    raise "This file is not PNG." unless img_data.analysis(4, true) == "IHDR"
    img_data.analysis(8, true).unpack('NN')
  end
  private_module_function :get_png_size

  def get_jpg_size img_data
    a_part_of_jpg_code = [
      "\xc0", "\xc1", "\xc2", "\xc3", "\xc5", "\xc6", "\xc7",
      "\xc9", "\xca", "\xcb", "\xcd", "\xce", "\xcf",
    ]
    section_marker = "\xFF"
    img_data.analysis(2)
    while(true)
      marker, code, length = img_data.analysis(4, true).unpack('aan')
      raise "JPEG marker not found!" unless marker == section_marker
      if a_part_of_jpg_code.include?(code)
        return img_data.analysis(5, true).unpack('xnn')
      end
      img_data.analysis(length - 2, true)
    end
  end
  private_module_function :get_jpg_size

  def get_bmp_size img_data
    img_data.analysis(26, true).unpack("x18VV")
  end
  private_module_function :get_bmp_size

  def get_img_type img_data
    if img_data =~ /^GIF8[7,9]a/                      then :gif
    elsif img_data[0, 8] == "\x89PNG\x0d\x0a\x1a\x0a" then :png
    elsif img_data[0, 2] == "\xFF\xD8"                then :jpg
    elsif img_data[0, 2] == 'BM'                      then :bmp
    else  raise "Unsupported image type Error!!"
    end
  end
  private_module_function :get_img_type
end
