class String
  def to_url
    return if self.nil?
    self.downcase.tr("\"'", '').gsub(/\W/, ' ').strip.tr_s(' ', '-').tr(' ', '-').sub(/^$/, "-")
  end

  def nofollowify
    self.gsub(/<\s*a\s*(.+?)>/i, '<a \1 rel="nofollow">')
  end

  EMERY_TAG_KEY = EMERY_ATTRIBUTE_KEY = /[\w:_-]+/
  EMERY_ATTRIBUTE_VALUE = /(?:[A-Za-z0-9]+|(?:'[^']*?'|"[^"]*?"))/
  EMERY_ATTRIBUTE = /(?:#{EMERY_ATTRIBUTE_KEY}(?:\s*=\s*#{EMERY_ATTRIBUTE_VALUE})?)/
  EMERY_ATTRIBUTES = /(?:#{EMERY_ATTRIBUTE}(?:\s+#{EMERY_ATTRIBUTE})*)/
  TAG = %r{<[!/?\[]?(?:#{EMERY_TAG_KEY}|--)(?:\s+#{EMERY_ATTRIBUTES})?\s*(?:[!/?\]]+|--)?>}
  def strip_html
    self.gsub(TAG, '').gsub(/\s+/, ' ').strip
  end
  
  def eol_parse
    cr = "\015"
    lf = "\012"
    eol = cr + lf
    br = "<br />"
    return self.gsub(/#{eol}/, br).gsub(/#{cr}/, br).gsub(/#{lf}/, br)
  end

  def hankaku?
    self.match(/[^a-zA-Z0-9\-\+\:\<\>\"\'\=\#\$\&\(\)\^\~\|\@\[\`\{\;\}\,\]\*\%\_\?\!\.\/\b\s]/).nil?
  end

  def ngram n = 2, prefix = ""
    return nil if self.nil? || self.length < n
    result, chars, index = "", self.split(//), 0 
    while index < chars.size - (n - 1)
      word, i, empty = "", index, false
      while i < index + n
        empty = empty || chars[i].match(/　|\s/) != nil
        word << chars[i]
        i += 1
      end
      #word = word.gsub(/　|\s/, "")
      unless empty
#      if word.length == n
        result << prefix
        result << word
        result << " "
      end
      index += 1
    end
    result.empty? ? nil : result.strip
  end
end

class Time
  def convert_zone to_zone
    original_zone = ENV["TZ"]
    utc_time = dup.gmtime
    ENV["TZ"] = to_zone
    to_zone_time = utc_time.localtime
    ENV["TZ"] = original_zone
    return to_zone_time
  end
end

